/*****************************************************
This program was produced by the
CodeWizardAVR V2.03.4 Standard
Automatic Program Generator
 Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project :
Version :
Date    : 01.12.2010
Author  :
Company :
Comments:


Chip type           : ATtiny2313
Clock frequency     : 4,000000 MHz
Memory model        : Tiny
External RAM size   : 0
Data Stack size     : 32
*****************************************************/
typedef  unsigned char byte ;
typedef  unsigned int  real ;

#include <tiny2313.h>
#include <bcd.h>
#include <delay.h>

// I2C Bus functions
#asm
   .equ __i2c_port=0x1B ;PORTA
   .equ __sda_bit=0
   .equ __scl_bit=1
#endasm
#include <i2c.h>
#include <ds1307.h>


#define a 128 //    q0
#define b 64   //   q1
#define c 32   //   q2
#define d 16   //   q3                  
#define e 8   //    q4
#define f 4   //    q5
#define g 2   //    q6
#define dp 1  //    q7


#define reg_hold   PORTD.4     //  12  stcp    .  01
#define reg_clk    PORTD.1     //  11  shcp    0-1
#define reg_data   PORTD.0     //  14  ds     0  1    0-1  stcp

#define  nclk    PIND.2          // 1 
#define  ndata   PIND.3          // 2 
#define  button ~PINB.6          //   

#define  beep    PORTD.5         //     
#define  rele    PORTD.6         //   

//______________________________________________________________________________________________________

byte dig[] = {
  ~(a+b+c+d+e+f),    //0          
  ~(b+c),            //1
  ~(a+b+g+e+d),      //2
  ~(a+b+g+c+d),      //3
  ~(f+g+b+c) ,       //4
  ~(a+f+g+c+d) ,     //5
  ~(a+f+g+c+d+e) ,   //6
  ~(a+b+c)       ,   //7
  ~(a+b+c+d+e+f+g),  //8
  ~(a+b+c+d+f+g)  ,  //9
  ~(c+e+g)   ,       // n
  ~(a+e+f+g) ,       // f
  ~(c+d+e+g)   ,     // o
  ~0} ;              //

 byte number_razr[] =
  {
   1  ,                  //        PORTB.0             
    2  ,                //            PORTB.1
     4 ,               //                PORTB.2
      8               //                  PORTB.3
  } ;

byte ind[4],          //      0- , 3 - 
     cursor,           //     
     m,                 //     
     blink =0 ,            //     0.25                            //
     menu,                   //  1-view clock , 0 - view timer
     timer ,                   //    
     sec ,                   //        DS
     ontic ,                //       
     sec1  ,               //         
     ustmin =0,               //        
     usthour=0 ,              //       
     hour,                   //       ,
     min ,                   //                
     morgmin=0,            //        
     morghour=0 ,          //       
     swth_down=255,                //        0.5    -
     swtch_up ,                //      
     cnt,                    //     0
     point=0;               //   
//____________________________________________________________________________________________________

                                        //  output function in 74hc595 reg
//_____________________________________________________________________________________________________

 void reg_out(byte tmp)
 {   byte i;
  for  (i=0;i<8;i++)       //   8-   tmp
   {  PORTD=PIND&236;       //    0  
      reg_data = (tmp)&1 ;  //     
      reg_clk  = 1;         //  
      tmp= tmp>>1;          //    
   }
     reg_hold = 1;          //    8-  
 }

//_____________________________________________________________________________________________________

                                      // External Interrupt 0 service routine rising
//_____________________________________________________________________________________________________

interrupt [EXT_INT0] void ext_int0_isr(void)
 { EIFR=0;
   if  (ustmin || usthour)                                //      
    {
      if(ustmin)                       //      
       { if (ndata)                      //         1
           min= (min) ? min-1 : 0 ;     //     59
         else                               //     
            min=(min>=59) ? 59 : min+1 ; //       0
       }
     if (usthour)                        //     
       { if (ndata)                      //             1
            hour = (hour) ? hour-1 : 0 ;   //      23
         else                                      //      0
            hour = (hour>=23) ?  23 : hour+1 ; //       0
       }
      sec1=0;                             //   
      rtc_set_time(hour,min,0);           //   -  
     }
    else                                   //         
    {
     if (ndata)                           //    1
      timer= (timer>2) ? timer-2 : 0;     //      100 
     else                                  //   0
      timer=(timer>=99)?  99: timer+2 ;      //       0 
    }
    EIFR=0x40;
}
//__________________________________________________________________________________________________________

//_________________________________Control menu Function _________________________

 void menu_control (void)

 { menu= (timer&swth_down)? 0 :1;                 //    ,  
    if (point) sec++;            //    DS      1  
    if(timer==0) sec=0;      //     
    if (ontic) sec1++;     //     -   ontic=1 ,
                              //    ontic=0 , sec1-
  //_______________________________  _______________________________

     beep= (timer==1)? ~beep : 0; //    1   
     rele= (timer>1) ? 1:0;        //       

  //______________________________    ________________________________

    if (sec>59)               //  60  ,    0
      {timer = (timer==0)?0 : timer-1 ;    //  -1        0
       sec=0;
      }
  //_____________________________   
    swth_down = ((button & rele) && swtch_up)? (~swth_down) :swth_down;

  //___________________________      

   if( menu & (~rele) )           //    
  { if ((~button)&& (sec1>15))  //        15          
      { ontic=0;                //
         sec1=0;               //
         morgmin=0;          //   
         morghour=0;        //
         ustmin=0;          //     
         usthour=0;       //
      }
                                        //
     if (button && menu)      //         
     {   ontic=1 ;           //     
      if (sec1==5)          //   5       ,     
       { ustmin=1;         //   
         morgmin=255 ;   //  
       }
      if (sec1==10)    //      10
        {ustmin=0;    //       
         morgmin=0;  //
         usthour=1;     //
         morghour=255 ;   //    
        }
    }
  }
  //_____________________________   
  swtch_up=(button) ? 0:1 ;
 }
 //__________________________________________________________________________________________

                         // Timer0 int 0.5 sec
 //_____________________________________________________________________________________________________________

interrupt [TIM0_OVF] void timer0_ovf_isr(void)
 { TCNT0=0x1A;                             // reinitial timer0  17 
   cnt++;
  if (cnt>8)
  { cnt=0;
   menu_control();
   point=~point;
  }
 }
 //____________________________________________________________________________________________________________
 //                                         DS 1307 activation after  change battery and power on
 // -----------------------------------------------------------------------------------------------------------
 void DS1307_init (void)
  { byte second ;
    second=rtc_read(0);  //     
    rtc_write(0,(second &= 0x7f)); //   7 (CH)   DS1307  ..  "1"
  }
//_______________________________________________________________________________________________________________
//
//                                indicator    =1    ,menu=0  
//______________________________________________________________________________________________________________

 void ind_view ()
 { byte tmpsec,bcdhour,bcdmin,bcdtimer,tmp;
   if (menu)                                       //   =1
    {  rtc_get_time(&hour,&min,&tmpsec) ;         //    
      bcdhour = bin2bcd(hour) ;                   //     
      bcdmin = bin2bcd(min);                        //
      tmp = bcdhour >> 4;                         //    
      ind[0]= dig[bcdmin&15];                      //   
      ind[1]= dig[bcdmin>>4];                        //  
      ind[2]= dig[bcdhour&15]&(~(byte)(PINB.7)) ;  //      DS     1
      ind[3]= (tmp>0) ? dig[tmp]:dig[13];      //       0  
    }
   else                                       //  
   { bcdtimer = bin2bcd( timer) ;
     if(rele)                                 //     
     { ind[0] =  dig[bcdtimer&15] ;           //
       ind[1] =  dig[bcdtimer>>4] ;           //
       ind[2] = dig[10]&(254|(point)) ;   //    n . . . .
       ind[3] = dig[12];                       //    
      }
     else
     { ind[0] =  dig[13] ;                             // 
       ind[1] =  dig[11]&(254|(point));          //  F . . .
       ind[2] =  dig[11];                            //    F
       ind[3] =  dig[12];                           //    
     }
   }
 }

//____________________________________________________________________________________________________________
                                     // Timer 1 overflow interrupt service routine
                         //  cur refresh 62.5/255 = 245 hz                    ind refresh 245/4 = 61hz
//_____________________________________________________________________________________________________________

interrupt [TIM1_OVF] void timer1_ovf_isr(void)
{  TCNT1H=0xFF;            //    
   TCNT1L=0x00;
   PORTB=240;            //  
   reg_out(ind[cursor]); //      +    3      
   PORTB=((PINB&240) | number_razr[cursor])& (255-( blink &(( 12 & morghour) + ( 3 & morgmin )))) ;// . 
   cursor++;      //           
 if (cursor>3)    //     4
    cursor=0;   //    
    m++;            //   ++
 if (m>30)            //  0.125  
  {  ind_view () ;      //  digit on indicator refresh
     blink=~ blink;   //    0.125
     m=0;
   }
}
//______________________________________________________________________________________________________________
                                   // Main programm
//______________________________________________________________________________________________________________
 void main(void)
{ // Crystal Oscillator division factor: 1
#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif
// Input/Output Ports initialization
// Port A initialization
// Func2=In Func1=In Func0=In
// State2=T State1=T State0=T
PORTA=0x00;
DDRA=0x00;

// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=Out Func2=Out Func1=Out Func0=Out
// State7=P State6=P State5=P State4=P State3=0 State2=0 State1=0 State0=0
PORTB=0xF0;
DDRB=0x0F;
// Port D initialization
// Func6=Out Func5=Out Func4=Out Func3=In Func2=In Func1=Out Func0=Out
// State6=0 State5=0 State4=0 State3=P State2=P State1=0 State0=0
PORTD=0x0C;
DDRD=0x73;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 3,906 kHz
// Mode: Normal top=FFh
// OC0A output: Disconnected
// OC0B output: Disconnected
//TCCR0A=0x00;
TCCR0B=0x05;
TCNT0=0x1A;
//OCR0A=0x00;
//OCR0B=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 62,500 kHz

TCCR1B=0x03;
TCNT1H=0xFF;

                 // External Interrupt(s) initialization    PINB.7    DS1307
// INT0: On
// INT0 Mode: rising edge - 0 to 1
// INT1: Off
// Interrupt on any change on pins PCINT0-7: off
GIMSK=0x40;
MCUCR=0x03;   //0x01 - any  ,0x02-- 1/0 ,  0x03-- 0/1
PCMSK=0x00;
EIFR=0x40;
                            // Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x82;
// Universal Serial Interface initialization
// Mode: Disabled
// Clock source: Register & Counter=no clk.
// USI Counter Overflow Interrupt: Off
//USICR=0x00;
                        // Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
//ACSR=0x80;
//_____________________________________________________________________________________________________________
                                  // I2C Bus initialization
                                 // DS1307 Real Time Clock initialization
                                // Square wave output on pin SQW/OUT: On
                               // Square wave frequency: 1Hz
//_____________________________________________________________________________________________________________
         i2c_init();
        rtc_init(0,1,1);
       DS1307_init ();
                                 // Global enable interrupts
//_____________________________________________________________________________________________________________
   #asm("sei")
     while(1){;}
}
