
typedef  unsigned char byte ;
typedef  unsigned int  real ;

#pragma used+
sfrb DIDR=1;
sfrb UBRRH=2;
sfrb UCSRC=3;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb USICR=0xd;
sfrb USISR=0xe;
sfrb USIDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb GPIOR0=0x13;
sfrb GPIOR1=0x14;
sfrb GPIOR2=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1D;
sfrb EEAR=0x1e;
sfrb PCMSK=0x20;
sfrb WDTCR=0x21;
sfrb TCCR1C=0x22;
sfrb GTCCR=0x23;
sfrb ICR1L=0x24;
sfrb ICR1H=0x25;
sfrw ICR1=0x24;   
sfrb CLKPR=0x26;
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;   
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;   
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb TCCR0A=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0B=0x33;
sfrb MCUSR=0x34;
sfrb MCUCR=0x35;
sfrb OCR0A=0x36;
sfrb SPMCSR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb EIFR=0x3a;
sfrb GIMSK=0x3b;
sfrb OCR0B=0x3c;
sfrb SPL=0x3d;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x50
	.EQU __sm_powerdown=0x10
	.EQU __sm_standby=0x40
	.SET power_ctrl_reg=mcucr
	#endif
#endasm

#pragma used+

unsigned char bcd2bin(unsigned char n);
unsigned char bin2bcd(unsigned char n);

#pragma used-

#pragma library bcd.lib

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

#asm
   .equ __i2c_port=0x1B ;PORTA
   .equ __sda_bit=0
   .equ __scl_bit=1
#endasm

#pragma used+
void i2c_init(void);
unsigned char i2c_start(void);
void i2c_stop(void);
unsigned char i2c_read(unsigned char ack);
unsigned char i2c_write(unsigned char data);
#pragma used-

#pragma used+

unsigned char rtc_read(unsigned char address);
void rtc_write(unsigned char address,unsigned char data);
void rtc_init(unsigned char rs,unsigned char sqwe,unsigned char out);
void rtc_get_time(unsigned char *hour,unsigned char *min,unsigned char *sec);
void rtc_set_time(unsigned char hour,unsigned char min,unsigned char sec);
void rtc_get_date(unsigned char *date,unsigned char *month,unsigned char *year);
void rtc_set_date(unsigned char date,unsigned char month,unsigned char year);

#pragma used-
#pragma library ds1307.lib

byte dig[] = {
~(128 +64   +32   +16   +8   +4   ),    
~(64   +32   ),            
~(128 +64   +2   +8   +16   ),      
~(128 +64   +2   +32   +16   ),      
~(4   +2   +64   +32   ) ,       
~(128 +4   +2   +32   +16   ) ,     
~(128 +4   +2   +32   +16   +8   ) ,   
~(128 +64   +32   )       ,   
~(128 +64   +32   +16   +8   +4   +2   ),  
~(128 +64   +32   +16   +4   +2   )  ,  
~(32   +8   +2   )   ,       
~(128 +8   +4   +2   ) ,       
~(32   +16   +8   +2   )   ,     
~0} ;              

byte number_razr[] =
{
1  ,                  
2  ,                
4 ,               
8               
} ;

byte ind[4],          
cursor,           
m,                 
blink =0 ,            
menu,                   
timer ,                   
sec ,                   
ontic ,                
sec1  ,               
ustmin =0,               
usthour=0 ,              
hour,                   
min ,                   
morgmin=0,            
morghour=0 ,          
swth_down=255,         
swth_up;          

void reg_out(byte tmp)
{   byte i;
for  (i=0;i<8;i++)       
{  PORTD=PIND&236;       
PORTD.0      = (tmp)&1 ;  
PORTD.1       = 1;         
tmp= tmp>>1;          
}
PORTD.4      = 1;          
}

interrupt [2] void ext_int0_isr(void)
{
if  (ustmin || usthour)                                
{
if(ustmin)                       
{ if (PIND.3          )                      
min= (min) ? min-1 : 0 ;     
else                               
min=(min>=59) ? 59 : min+1 ; 
}
if (usthour)                        
{ if (PIND.3          )                      
hour = (hour) ? hour-1 : 0 ;   
else                                      
hour = (hour>=23) ?  23 : hour+1 ; 
}
sec1=0;                             
rtc_set_time(hour,min,0);           
}
else                                   
{
if (PIND.3          )                           
timer= (timer>2) ? timer-2 : 0;     
else                                  
timer=(timer>=99)?  99: timer+2 ;      
}
}

interrupt [12] void pin_change_isr0(void)
{ menu= (timer&swth_down)? 0 :1;                 
if (PINB.7           ) sec++;            
if(timer==0) sec=0;      
if (ontic) sec1++;     

PORTD.5         = (timer==1)? ~PORTD.5          : 0; 
PORTD.6         = (timer>1) ? 1:0;        

if (sec>59)               
{timer = (timer==0)?0 : timer-1 ;    
sec=0;
}

swth_down = ((~PINB.6           && PORTD.6         ) && swth_up)? (~swth_down) :swth_down;

if( menu & (~PORTD.6         ) )           
{ if ((~~PINB.6          )&& (sec1>15))  
{ ontic=0;                
sec1=0;               
morgmin=0;          
morghour=0;        
ustmin=0;          
usthour=0;       
}

if (~PINB.6           && menu)      
{   ontic=1 ;           
if (sec1==5)          
{ ustmin=1;         
morgmin=255 ;   
}
if (sec1==10)    
{ustmin=0;    
morgmin=0;  
usthour=1;     
morghour=255 ;   
}
}
}

swth_up=(~PINB.6          ) ? 0:1 ;
}

void DS1307_init (void)
{ byte second ;
second=rtc_read(0);  
rtc_write(0,(second &= 0x7f)); 
}

void ind_view ()
{ byte tmpsec,bcdhour,bcdmin,bcdtimer,tmp;
if (menu)                                       
{  rtc_get_time(&hour,&min,&tmpsec) ;         
bcdhour = bin2bcd(hour) ;                   
bcdmin = bin2bcd(min);                        
tmp = bcdhour >> 4;                         
ind[0]= dig[bcdmin&15];                      
ind[1]= dig[bcdmin>>4];                        
ind[2]= dig[bcdhour&15]&(~ (byte)(PINB.7)) ;  
ind[3]= (tmp>0) ? dig[tmp]:dig[13];      
}
else                                       
{ bcdtimer = bin2bcd( timer) ;
if(PORTD.6         )                                 
{ ind[0] =  dig[bcdtimer&15] ;           
ind[1] =  dig[bcdtimer>>4] ;           
ind[2] = dig[10]&(~ (byte)(PINB.7)) ;   
ind[3] = dig[12];                       
}
else
{ ind[0] =  dig[13] ;                             
ind[1] =  dig[11]&(~ (byte)(PINB.7));          
ind[2] =  dig[11];                            
ind[3] =  dig[12];                           
}
}
}

interrupt [6] void timer1_ovf_isr(void)
{  TCNT1H=0xFF;    
TCNT1L=0x00;
PORTB=240;     
reg_out(ind[cursor]); 
PORTB=((PINB&240) | number_razr[cursor])& (255-( blink &(( 12 & morghour) + ( 3 & morgmin )))) ;
cursor++;      
if (cursor>3)    
cursor=0;   
m++;            
if (m>30)            
{  ind_view () ;      
blink=~ blink;   
m=0;
}
}

void main(void)
{ 
#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#pragma optsize+

PORTA=0x00;
DDRA=0x00;

PORTB=0xF0;
DDRB=0x0F;

PORTD=0x0C;
DDRD=0x73;

TCCR1B=0x03;
TCNT1H=0xFF;

GIMSK=0x60;
MCUCR=0x03;   
PCMSK=0x80;
EIFR=0x60;

TIMSK=0x80;

i2c_init();
rtc_init(0,1,1);
DS1307_init ();

#asm("sei")

}
