
;CodeVisionAVR C Compiler V2.04.4a Advanced
;(C) Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATtiny2313
;Program type             : Application
;Clock frequency          : 4,000000 MHz
;Memory model             : Tiny
;Optimize for             : Size
;(s)printf features       : int
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 48 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : No
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: No
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATtiny2313
	#pragma AVRPART MEMORY PROG_FLASH 2048
	#pragma AVRPART MEMORY EEPROM 128
	#pragma AVRPART MEMORY INT_SRAM SIZE 128
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU WDTCR=0x21
	.EQU MCUSR=0x34
	.EQU MCUCR=0x35
	.EQU SPL=0x3D
	.EQU SREG=0x3F
	.EQU GPIOR0=0x13
	.EQU GPIOR1=0x14
	.EQU GPIOR2=0x15

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOV  R26,R@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _cursor=R3
	.DEF _m=R2
	.DEF _blink=R5
	.DEF _menu=R4
	.DEF _timer=R7
	.DEF _sec=R6
	.DEF _ontic=R9
	.DEF _sec1=R8
	.DEF _ustmin=R11
	.DEF _usthour=R10
	.DEF _hour=R13
	.DEF _min=R12

	.CSEG
	.ORG 0x00

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP _ext_int0_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer1_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _pin_change_isr0
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_0x3:
	.DB  0x3,0x9F,0x25,0xD,0x99,0x49,0x41,0x1F
	.DB  0x1,0x9,0xD5,0x71,0xC5,0xFF
_0x4:
	.DB  0x1,0x2,0x4,0x8
_0x5:
	.DB  0x0
_0x6:
	.DB  0x0
_0x7:
	.DB  0xFF
_0x66:
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0

__GLOBAL_INI_TBL:
	.DW  0x0E
	.DW  _dig
	.DW  _0x3*2

	.DW  0x04
	.DW  _number_razr
	.DW  _0x4*2

	.DW  0x01
	.DW  _morgmin
	.DW  _0x5*2

	.DW  0x01
	.DW  _morghour
	.DW  _0x6*2

	.DW  0x01
	.DW  _swth_down
	.DW  _0x7*2

	.DW  0x07
	.DW  0x05
	.DW  _0x66*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	IN   R26,MCUSR
	CBR  R26,8
	OUT  MCUSR,R26
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;GPIOR0-GPIOR2 INITIALIZATION
	LDI  R30,0x00
	OUT  GPIOR0,R30
	OUT  GPIOR1,R30
	OUT  GPIOR2,R30

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0xDF)
	OUT  SPL,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x90)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x90

	.CSEG
;/*****************************************************
;This program was produced by the
;CodeWizardAVR V2.03.4 Standard
;Automatic Program Generator
; Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project :
;Version :
;Date    : 01.12.2010
;Author  :
;Company :
;Comments:
;
;
;Chip type           : ATtiny2313
;Clock frequency     : 4,000000 MHz
;Memory model        : Tiny
;External RAM size   : 0
;Data Stack size     : 32
;*****************************************************/
;typedef  unsigned char byte ;
;typedef  unsigned int  real ;
;
;#include <tiny2313.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x50
	.EQU __sm_powerdown=0x10
	.EQU __sm_standby=0x40
	.SET power_ctrl_reg=mcucr
	#endif
;#include <bcd.h>
;#include <delay.h>
;
;// I2C Bus functions
;#asm
   .equ __i2c_port=0x1B ;PORTA
   .equ __sda_bit=0
   .equ __scl_bit=1
; 0000 0022 #endasm
;#include <i2c.h>
;#include <ds1307.h>
;
;
;#define a 128 //    q0
;#define b 64   //   q1
;#define c 32   //   q2
;#define d 16   //   q3                  
;#define e 8   //    q4
;#define f 4   //    q5
;#define g 2   //    q6
;#define dp 1  //    q7
;
;#define point PINB.7           //   DS1307  
;#define reg_hold   PORTD.4     //  12  stcp    .  01
;#define reg_clk    PORTD.1     //  11  shcp    0-1
;#define reg_data   PORTD.0     //  14  ds     0  1    0-1  stcp
;
;#define  nclk    PIND.2          // 1 
;#define  ndata   PIND.3          // 2 
;#define  button ~PINB.6          //   
;
;#define  beep    PORTD.5         //     
;#define  rele    PORTD.6         //   
;
;//______________________________________________________________________________________________________
;
;byte dig[] = {
;  ~(a+b+c+d+e+f),    //0          
;  ~(b+c),            //1
;  ~(a+b+g+e+d),      //2
;  ~(a+b+g+c+d),      //3
;  ~(f+g+b+c) ,       //4
;  ~(a+f+g+c+d) ,     //5
;  ~(a+f+g+c+d+e) ,   //6
;  ~(a+b+c)       ,   //7
;  ~(a+b+c+d+e+f+g),  //8
;  ~(a+b+c+d+f+g)  ,  //9
;  ~(c+e+g)   ,       // n
;  ~(a+e+f+g) ,       // f
;  ~(c+d+e+g)   ,     // o
;  ~0} ;              //

	.DSEG
;
; byte number_razr[] =
;  {
;   1  ,                  //        PORTB.0             
;    2  ,                //            PORTB.1
;     4 ,               //                PORTB.2
;      8               //                  PORTB.3
;  } ;
;
;byte ind[4],          //      0- , 3 - 
;     cursor,           //     
;     m,                 //     
;     blink =0 ,            //     0.25   
;     menu,                   //  1-view clock , 0 - view timer
;     timer ,                   //    
;     sec ,                   //        DS
;     ontic ,                //       
;     sec1  ,               //         
;     ustmin =0,               //        
;     usthour=0 ,              //       
;     hour,                   //       ,
;     min ,                   //                
;     morgmin=0,            //        
;     morghour=0 ,          //       
;     swth_down=255,         //        0.5    -
;     swth_up;          //                 
;//____________________________________________________________________________________________________
;
;                                        //  output function in 74hc595 reg
;//_____________________________________________________________________________________________________
;
; void reg_out(byte tmp)
; 0000 006D  {   byte i;

	.CSEG
_reg_out:
; 0000 006E   for  (i=0;i<8;i++)       //   8-   tmp
	ST   -Y,R17
;	tmp -> Y+1
;	i -> R17
	LDI  R17,LOW(0)
_0x9:
	CPI  R17,8
	BRSH _0xA
; 0000 006F    {  PORTD=PIND&236;       //    0  
	IN   R30,0x10
	ANDI R30,LOW(0xEC)
	OUT  0x12,R30
; 0000 0070       reg_data = (tmp)&1 ;  //     
	LDD  R30,Y+1
	ANDI R30,LOW(0x1)
	BRNE _0xB
	CBI  0x12,0
	RJMP _0xC
_0xB:
	SBI  0x12,0
_0xC:
; 0000 0071       reg_clk  = 1;         //  
	SBI  0x12,1
; 0000 0072       tmp= tmp>>1;          //    
	LDD  R30,Y+1
	LSR  R30
	STD  Y+1,R30
; 0000 0073    }
	SUBI R17,-1
	RJMP _0x9
_0xA:
; 0000 0074      reg_hold = 1;          //    8-  
	SBI  0x12,4
; 0000 0075  }
	LDD  R17,Y+0
	RJMP _0x2040003
;
;//_____________________________________________________________________________________________________
;
;                                      // External Interrupt 0 service routine rising
;//_____________________________________________________________________________________________________
;
;interrupt [EXT_INT0] void ext_int0_isr(void)
; 0000 007D  {
_ext_int0_isr:
	RCALL SUBOPT_0x0
; 0000 007E    if  (ustmin || usthour)                                //      
	TST  R11
	BRNE _0x12
	TST  R10
	BREQ _0x11
_0x12:
; 0000 007F     {
; 0000 0080       if(ustmin)                       //      
	TST  R11
	BREQ _0x14
; 0000 0081        { if (ndata)                      //         1
	SBIS 0x10,3
	RJMP _0x15
; 0000 0082            min= (min) ? min-1 : 0 ;     //     59
	TST  R12
	BREQ _0x16
	MOV  R30,R12
	SUBI R30,LOW(1)
	RJMP _0x17
_0x16:
	LDI  R30,LOW(0)
_0x17:
	RJMP _0x60
; 0000 0083          else                               //     
_0x15:
; 0000 0084             min=(min>=59) ? 59 : min+1 ; //       0
	LDI  R30,LOW(59)
	CP   R12,R30
	BRLO _0x1A
	RJMP _0x1B
_0x1A:
	MOV  R30,R12
	SUBI R30,-LOW(1)
_0x1B:
_0x60:
	MOV  R12,R30
; 0000 0085        }
; 0000 0086      if (usthour)                        //     
_0x14:
	TST  R10
	BREQ _0x1D
; 0000 0087        { if (ndata)                      //             1
	SBIS 0x10,3
	RJMP _0x1E
; 0000 0088             hour = (hour) ? hour-1 : 0 ;   //      23
	TST  R13
	BREQ _0x1F
	MOV  R30,R13
	SUBI R30,LOW(1)
	RJMP _0x20
_0x1F:
	LDI  R30,LOW(0)
_0x20:
	RJMP _0x61
; 0000 0089          else                                      //      0
_0x1E:
; 0000 008A             hour = (hour>=23) ?  23 : hour+1 ; //       0
	LDI  R30,LOW(23)
	CP   R13,R30
	BRLO _0x23
	RJMP _0x24
_0x23:
	MOV  R30,R13
	SUBI R30,-LOW(1)
_0x24:
_0x61:
	MOV  R13,R30
; 0000 008B        }
; 0000 008C       sec1=0;                             //   
_0x1D:
	CLR  R8
; 0000 008D       rtc_set_time(hour,min,0);           //   -  
	ST   -Y,R13
	ST   -Y,R12
	RCALL SUBOPT_0x1
	RCALL _rtc_set_time
; 0000 008E      }
; 0000 008F     else                                   //         
	RJMP _0x26
_0x11:
; 0000 0090     {
; 0000 0091      if (ndata)                           //    1
	SBIS 0x10,3
	RJMP _0x27
; 0000 0092       timer= (timer>2) ? timer-2 : 0;     //      100 
	LDI  R30,LOW(2)
	CP   R30,R7
	BRSH _0x28
	MOV  R30,R7
	SUBI R30,LOW(2)
	RJMP _0x29
_0x28:
	LDI  R30,LOW(0)
_0x29:
	RJMP _0x62
; 0000 0093      else                                  //   0
_0x27:
; 0000 0094       timer=(timer>=99)?  99: timer+2 ;      //       0 
	LDI  R30,LOW(99)
	CP   R7,R30
	BRLO _0x2C
	RJMP _0x2D
_0x2C:
	MOV  R30,R7
	SUBI R30,-LOW(2)
_0x2D:
_0x62:
	MOV  R7,R30
; 0000 0095     }
_0x26:
; 0000 0096  }
	RJMP _0x65
;//__________________________________________________________________________________________________________
;
;                         // Pin any change PINB 7 interrupt service routine any 0.5 sec
;//_____________________________________________________________________________________________________________
;
;interrupt [PC_INT] void pin_change_isr0(void)
; 0000 009D   { menu= (timer&swth_down)? 0 :1;                 //    ,  
_pin_change_isr0:
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
	LDS  R30,_swth_down
	AND  R30,R7
	BREQ _0x2F
	LDI  R30,LOW(0)
	RJMP _0x30
_0x2F:
	LDI  R30,LOW(1)
_0x30:
	MOV  R4,R30
; 0000 009E     if (point) sec++;            //    DS      1  
	SBIC 0x16,7
	INC  R6
; 0000 009F     if(timer==0) sec=0;      //     
	TST  R7
	BRNE _0x33
	CLR  R6
; 0000 00A0     if (ontic) sec1++;     //     -   ontic=1 ,
_0x33:
	TST  R9
	BREQ _0x34
	INC  R8
; 0000 00A1                               //    ontic=0 , sec1-
; 0000 00A2   //_______________________________  _______________________________
; 0000 00A3 
; 0000 00A4      beep= (timer==1)? ~beep : 0; //    1   
_0x34:
	LDI  R30,LOW(1)
	CP   R30,R7
	BRNE _0x35
	LDI  R30,0
	SBIS 0x12,5
	LDI  R30,1
	RJMP _0x36
_0x35:
	LDI  R30,LOW(0)
_0x36:
	CPI  R30,0
	BRNE _0x38
	CBI  0x12,5
	RJMP _0x39
_0x38:
	SBI  0x12,5
_0x39:
; 0000 00A5      rele= (timer>1) ? 1:0;        //       
	LDI  R30,LOW(1)
	CP   R30,R7
	BRSH _0x3A
	RJMP _0x3B
_0x3A:
	LDI  R30,LOW(0)
_0x3B:
	CPI  R30,0
	BRNE _0x3D
	CBI  0x12,6
	RJMP _0x3E
_0x3D:
	SBI  0x12,6
_0x3E:
; 0000 00A6 
; 0000 00A7   //______________________________    ________________________________
; 0000 00A8 
; 0000 00A9     if (sec>59)               //  60  ,    0
	LDI  R30,LOW(59)
	CP   R30,R6
	BRSH _0x3F
; 0000 00AA       {timer = (timer==0)?0 : timer-1 ;    //  -1        0
	LDI  R30,LOW(0)
	CP   R30,R7
	BRNE _0x40
	RJMP _0x41
_0x40:
	MOV  R30,R7
	SUBI R30,LOW(1)
_0x41:
	MOV  R7,R30
; 0000 00AB        sec=0;
	CLR  R6
; 0000 00AC       }
; 0000 00AD   //_____________________________   
; 0000 00AE     swth_down = ((button && rele) && swth_up)? (~swth_down) :swth_down;
_0x3F:
	SBIC 0x16,6
	RJMP _0x43
	SBIC 0x12,6
	RJMP _0x44
_0x43:
	RJMP _0x45
_0x44:
	LDS  R30,_swth_up
	CPI  R30,0
	BRNE _0x46
_0x45:
	RJMP _0x47
_0x46:
	LDS  R30,_swth_down
	COM  R30
	RJMP _0x48
_0x47:
	LDS  R30,_swth_down
_0x48:
	STS  _swth_down,R30
; 0000 00AF 
; 0000 00B0   //___________________________      
; 0000 00B1 
; 0000 00B2    if( menu & (~rele) )           //    
	LDI  R30,0
	SBIS 0x12,6
	LDI  R30,1
	AND  R30,R4
	BREQ _0x4A
; 0000 00B3   { if ((~button)&& (sec1>15))  //        15          
	LDI  R30,0
	SBIS 0x16,6
	LDI  R30,1
	COM  R30
	CPI  R30,0
	BREQ _0x4C
	LDI  R30,LOW(15)
	CP   R30,R8
	BRLO _0x4D
_0x4C:
	RJMP _0x4B
_0x4D:
; 0000 00B4       { ontic=0;                //
	CLR  R9
; 0000 00B5          sec1=0;               //
	CLR  R8
; 0000 00B6          morgmin=0;          //   
	LDI  R30,LOW(0)
	STS  _morgmin,R30
; 0000 00B7          morghour=0;        //
	STS  _morghour,R30
; 0000 00B8          ustmin=0;          //     
	CLR  R11
; 0000 00B9          usthour=0;       //
	CLR  R10
; 0000 00BA       }
; 0000 00BB                                         //
; 0000 00BC      if (button && menu)      //         
_0x4B:
	SBIC 0x16,6
	RJMP _0x4F
	TST  R4
	BRNE _0x50
_0x4F:
	RJMP _0x4E
_0x50:
; 0000 00BD      {   ontic=1 ;           //     
	LDI  R30,LOW(1)
	MOV  R9,R30
; 0000 00BE       if (sec1==5)          //   5       ,     
	LDI  R30,LOW(5)
	CP   R30,R8
	BRNE _0x51
; 0000 00BF        { ustmin=1;         //   
	LDI  R30,LOW(1)
	MOV  R11,R30
; 0000 00C0          morgmin=255 ;   //  
	LDI  R30,LOW(255)
	STS  _morgmin,R30
; 0000 00C1        }
; 0000 00C2       if (sec1==10)    //      10
_0x51:
	LDI  R30,LOW(10)
	CP   R30,R8
	BRNE _0x52
; 0000 00C3         {ustmin=0;    //       
	CLR  R11
; 0000 00C4          morgmin=0;  //
	LDI  R30,LOW(0)
	STS  _morgmin,R30
; 0000 00C5          usthour=1;     //
	LDI  R30,LOW(1)
	MOV  R10,R30
; 0000 00C6          morghour=255 ;   //    
	LDI  R30,LOW(255)
	STS  _morghour,R30
; 0000 00C7         }
; 0000 00C8     }
_0x52:
; 0000 00C9   }
_0x4E:
; 0000 00CA   //_____________________________   
; 0000 00CB   swth_up=(button) ? 0:1 ;
_0x4A:
	SBIC 0x16,6
	RJMP _0x53
	LDI  R30,LOW(0)
	RJMP _0x54
_0x53:
	LDI  R30,LOW(1)
_0x54:
	STS  _swth_up,R30
; 0000 00CC  }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	RETI
; //____________________________________________________________________________________________________________
; //                                         DS 1307 activation after  change battery and power on
; // -----------------------------------------------------------------------------------------------------------
; void DS1307_init (void)
; 0000 00D1   { byte second ;
_DS1307_init:
; 0000 00D2     second=rtc_read(0);  //     
	ST   -Y,R17
;	second -> R17
	RCALL SUBOPT_0x1
	RCALL _rtc_read
	MOV  R17,R30
; 0000 00D3     rtc_write(0,(second &= 0x7f)); //   7 (CH)   DS1307  ..  "1"
	RCALL SUBOPT_0x1
	MOV  R30,R17
	ANDI R30,0x7F
	MOV  R17,R30
	ST   -Y,R30
	RCALL _rtc_write
; 0000 00D4   }
	LD   R17,Y+
	RET
;//_______________________________________________________________________________________________________________
;//
;//                                indicator    =1    ,menu=0  
;//______________________________________________________________________________________________________________
;
; void ind_view ()
; 0000 00DB  { byte tmpsec,bcdhour,bcdmin,bcdtimer,tmp;
_ind_view:
; 0000 00DC    if (menu)                                       //   =1
	RCALL __SAVELOCR6
;	tmpsec -> R17
;	bcdhour -> R16
;	bcdmin -> R19
;	bcdtimer -> R18
;	tmp -> R21
	TST  R4
	BREQ _0x56
; 0000 00DD     {  rtc_get_time(&hour,&min,&tmpsec) ;         //    
	LDI  R30,LOW(13)
	ST   -Y,R30
	LDI  R30,LOW(12)
	ST   -Y,R30
	IN   R30,SPL
	ST   -Y,R30
	PUSH R17
	RCALL _rtc_get_time
	POP  R17
; 0000 00DE       bcdhour = bin2bcd(hour) ;                   //     
	ST   -Y,R13
	RCALL _bin2bcd
	MOV  R16,R30
; 0000 00DF       bcdmin = bin2bcd(min);                        //
	ST   -Y,R12
	RCALL _bin2bcd
	MOV  R19,R30
; 0000 00E0       tmp = bcdhour >> 4;                         //    
	MOV  R30,R16
	SWAP R30
	ANDI R30,0xF
	MOV  R21,R30
; 0000 00E1       ind[0]= dig[bcdmin&15];                      //   
	MOV  R30,R19
	ANDI R30,LOW(0xF)
	RCALL SUBOPT_0x2
	STS  _ind,R30
; 0000 00E2       ind[1]= dig[bcdmin>>4];                        //  
	MOV  R30,R19
	SWAP R30
	ANDI R30,0xF
	RCALL SUBOPT_0x2
	__PUTB1MN _ind,1
; 0000 00E3       ind[2]= dig[bcdhour&15]&(~ (byte)(PINB.7)) ;  //      DS     1
	MOV  R30,R16
	ANDI R30,LOW(0xF)
	SUBI R30,-LOW(_dig)
	LD   R26,Z
	RCALL SUBOPT_0x3
	__PUTB1MN _ind,2
; 0000 00E4       ind[3]= (tmp>0) ? dig[tmp]:dig[13];      //       0  
	CPI  R21,1
	BRLO _0x57
	LDI  R26,LOW(_dig)
	ADD  R26,R21
	LD   R30,X
	RJMP _0x58
_0x57:
	__GETB1MN _dig,13
_0x58:
	RJMP _0x63
; 0000 00E5     }
; 0000 00E6    else                                       //  
_0x56:
; 0000 00E7    { bcdtimer = bin2bcd( timer) ;
	ST   -Y,R7
	RCALL _bin2bcd
	MOV  R18,R30
; 0000 00E8      if(rele)                                 //     
	SBIS 0x12,6
	RJMP _0x5B
; 0000 00E9      { ind[0] =  dig[bcdtimer&15] ;           //
	MOV  R30,R18
	ANDI R30,LOW(0xF)
	RCALL SUBOPT_0x2
	STS  _ind,R30
; 0000 00EA        ind[1] =  dig[bcdtimer>>4] ;           //
	MOV  R30,R18
	SWAP R30
	ANDI R30,0xF
	RCALL SUBOPT_0x2
	__PUTB1MN _ind,1
; 0000 00EB        ind[2] = dig[10]&(~ (byte)(PINB.7)) ;   //    n . . . .
	__GETB2MN _dig,10
	RCALL SUBOPT_0x3
	RJMP _0x64
; 0000 00EC        ind[3] = dig[12];                       //    
; 0000 00ED       }
; 0000 00EE      else
_0x5B:
; 0000 00EF      { ind[0] =  dig[13] ;                             // 
	__GETB1MN _dig,13
	STS  _ind,R30
; 0000 00F0        ind[1] =  dig[11]&(~ (byte)(PINB.7));          //  F . . .
	__GETB2MN _dig,11
	RCALL SUBOPT_0x3
	__PUTB1MN _ind,1
; 0000 00F1        ind[2] =  dig[11];                            //    F
	__GETB1MN _dig,11
_0x64:
	__PUTB1MN _ind,2
; 0000 00F2        ind[3] =  dig[12];                           //    
	__GETB1MN _dig,12
_0x63:
	__PUTB1MN _ind,3
; 0000 00F3      }
; 0000 00F4    }
; 0000 00F5  }
	RCALL __LOADLOCR6
	ADIW R28,6
	RET
;
;//____________________________________________________________________________________________________________
;                                     // Timer 1 overflow interrupt service routine
;                         //  cur refresh 62.5/255 = 245 hz                    ind refresh 245/4 = 61hz
;//_____________________________________________________________________________________________________________
;
;interrupt [TIM1_OVF] void timer1_ovf_isr(void)
; 0000 00FD {  TCNT1H=0xFF;    //    1
_timer1_ovf_isr:
	RCALL SUBOPT_0x0
	LDI  R30,LOW(255)
	OUT  0x2D,R30
; 0000 00FE    TCNT1L=0x00;
	LDI  R30,LOW(0)
	OUT  0x2C,R30
; 0000 00FF    PORTB=240;     // 
	LDI  R30,LOW(240)
	OUT  0x18,R30
; 0000 0100    reg_out(ind[cursor]); //      +    3      
	LDI  R26,LOW(_ind)
	ADD  R26,R3
	LD   R30,X
	ST   -Y,R30
	RCALL _reg_out
; 0000 0101    PORTB=((PINB&240) | number_razr[cursor])& (255-( blink &(( 12 & morghour) + ( 3 & morgmin )))) ;// . 
	IN   R30,0x16
	ANDI R30,LOW(0xF0)
	MOV  R0,R30
	LDI  R26,LOW(_number_razr)
	ADD  R26,R3
	LD   R30,X
	OR   R0,R30
	LDS  R30,_morghour
	ANDI R30,LOW(0xC)
	MOV  R26,R30
	LDS  R30,_morgmin
	ANDI R30,LOW(0x3)
	ADD  R30,R26
	AND  R30,R5
	LDI  R26,LOW(255)
	RCALL __SWAPB12
	SUB  R30,R26
	AND  R30,R0
	OUT  0x18,R30
; 0000 0102    cursor++;      //           
	INC  R3
; 0000 0103  if (cursor>3)    //     4
	LDI  R30,LOW(3)
	CP   R30,R3
	BRSH _0x5D
; 0000 0104     cursor=0;   //    
	CLR  R3
; 0000 0105     m++;            //   ++
_0x5D:
	INC  R2
; 0000 0106  if (m>30)            //  0.125  
	LDI  R30,LOW(30)
	CP   R30,R2
	BRSH _0x5E
; 0000 0107   {  ind_view () ;      //  digit on indicator refresh
	RCALL _ind_view
; 0000 0108      blink=~ blink;   //    0.125
	COM  R5
; 0000 0109      m=0;
	CLR  R2
; 0000 010A    }
; 0000 010B }
_0x5E:
_0x65:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;//______________________________________________________________________________________________________________
;                                   // Main programm
;//______________________________________________________________________________________________________________
; void main(void)
; 0000 0110 { // Crystal Oscillator division factor: 1
_main:
; 0000 0111 #pragma optsize-
; 0000 0112 CLKPR=0x80;
	LDI  R30,LOW(128)
	OUT  0x26,R30
; 0000 0113 CLKPR=0x00;
	LDI  R30,LOW(0)
	OUT  0x26,R30
; 0000 0114 #ifdef _OPTIMIZE_SIZE_
; 0000 0115 #pragma optsize+
; 0000 0116 #endif
; 0000 0117 // Input/Output Ports initialization
; 0000 0118 // Port A initialization
; 0000 0119 // Func2=In Func1=In Func0=In
; 0000 011A // State2=T State1=T State0=T
; 0000 011B PORTA=0x00;
	OUT  0x1B,R30
; 0000 011C DDRA=0x00;
	OUT  0x1A,R30
; 0000 011D 
; 0000 011E // Port B initialization
; 0000 011F // Func7=In Func6=In Func5=In Func4=In Func3=Out Func2=Out Func1=Out Func0=Out
; 0000 0120 // State7=P State6=P State5=P State4=P State3=0 State2=0 State1=0 State0=0
; 0000 0121 PORTB=0xF0;
	LDI  R30,LOW(240)
	OUT  0x18,R30
; 0000 0122 DDRB=0x0F;
	LDI  R30,LOW(15)
	OUT  0x17,R30
; 0000 0123 // Port D initialization
; 0000 0124 // Func6=Out Func5=Out Func4=Out Func3=In Func2=In Func1=Out Func0=Out
; 0000 0125 // State6=0 State5=0 State4=0 State3=P State2=P State1=0 State0=0
; 0000 0126 PORTD=0x0C;
	LDI  R30,LOW(12)
	OUT  0x12,R30
; 0000 0127 DDRD=0x73;
	LDI  R30,LOW(115)
	OUT  0x11,R30
; 0000 0128 
; 0000 0129 // Timer/Counter 1 initialization
; 0000 012A // Clock source: System Clock
; 0000 012B // Clock value: 62,500 kHz
; 0000 012C 
; 0000 012D TCCR1B=0x03;
	LDI  R30,LOW(3)
	OUT  0x2E,R30
; 0000 012E TCNT1H=0xFF;
	LDI  R30,LOW(255)
	OUT  0x2D,R30
; 0000 012F 
; 0000 0130                  // External Interrupt(s) initialization    PINB.7    DS1307
; 0000 0131 // INT0: On
; 0000 0132 // INT0 Mode: rising edge - 0 to 1
; 0000 0133 // INT1: Off
; 0000 0134 // Interrupt on any change on pins PCINT0-7: On
; 0000 0135 GIMSK=0x60;
	LDI  R30,LOW(96)
	OUT  0x3B,R30
; 0000 0136 MCUCR=0x03;   //0x01 - any  ,0x02-- 1/0 ,  0x03-- 0/1
	LDI  R30,LOW(3)
	OUT  0x35,R30
; 0000 0137 PCMSK=0x80;
	LDI  R30,LOW(128)
	OUT  0x20,R30
; 0000 0138 EIFR=0x60;
	LDI  R30,LOW(96)
	OUT  0x3A,R30
; 0000 0139                             // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 013A TIMSK=0x80;
	LDI  R30,LOW(128)
	OUT  0x39,R30
; 0000 013B // Universal Serial Interface initialization
; 0000 013C // Mode: Disabled
; 0000 013D // Clock source: Register & Counter=no clk.
; 0000 013E // USI Counter Overflow Interrupt: Off
; 0000 013F //USICR=0x00;
; 0000 0140                         // Analog Comparator initialization
; 0000 0141 // Analog Comparator: Off
; 0000 0142 // Analog Comparator Input Capture by Timer/Counter 1: Off
; 0000 0143 //ACSR=0x80;
; 0000 0144 //_____________________________________________________________________________________________________________
; 0000 0145                                   // I2C Bus initialization
; 0000 0146                                  // DS1307 Real Time Clock initialization
; 0000 0147                                 // Square wave output on pin SQW/OUT: On
; 0000 0148                                // Square wave frequency: 1Hz
; 0000 0149 //_____________________________________________________________________________________________________________
; 0000 014A          i2c_init();
	RCALL _i2c_init
; 0000 014B         rtc_init(0,1,1);
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x4
	RCALL _rtc_init
; 0000 014C        DS1307_init ();
	RCALL _DS1307_init
; 0000 014D                                  // Global enable interrupts
; 0000 014E //_____________________________________________________________________________________________________________
; 0000 014F    #asm("sei")
	sei
; 0000 0150 
; 0000 0151 }
_0x5F:
	RJMP _0x5F

	.CSEG
_bcd2bin:
    ld   r30,y
    swap r30
    andi r30,0xf
    mov  r26,r30
    lsl  r26
    lsl  r26
    add  r30,r26
    lsl  r30
    ld   r26,y+
    andi r26,0xf
    add  r30,r26
    ret
_bin2bcd:
    ld   r26,y+
    clr  r30
bin2bcd0:
    subi r26,10
    brmi bin2bcd1
    subi r30,-16
    rjmp bin2bcd0
bin2bcd1:
    subi r26,-10
    add  r30,r26
    ret

	.CSEG
_rtc_read:
	ST   -Y,R17
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x1
	RCALL _i2c_read
	MOV  R17,R30
	RCALL _i2c_stop
	MOV  R30,R17
	LDD  R17,Y+0
	RJMP _0x2040003
_rtc_write:
	RCALL SUBOPT_0x5
	LD   R30,Y
	RCALL SUBOPT_0x7
	RCALL _i2c_stop
_0x2040003:
	ADIW R28,2
	RET
_rtc_init:
	LDD  R30,Y+2
	ANDI R30,LOW(0x3)
	STD  Y+2,R30
	LDD  R30,Y+1
	CPI  R30,0
	BREQ _0x2020003
	LDD  R30,Y+2
	ORI  R30,0x10
	STD  Y+2,R30
_0x2020003:
	LD   R30,Y
	CPI  R30,0
	BREQ _0x2020004
	LDD  R30,Y+2
	ORI  R30,0x80
	STD  Y+2,R30
_0x2020004:
	RCALL SUBOPT_0x8
	LDI  R30,LOW(7)
	RCALL SUBOPT_0x7
	LDD  R30,Y+2
	RJMP _0x2040002
_rtc_get_time:
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x1
	RCALL _i2c_write
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x9
	LD   R26,Y
	ST   X,R30
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x9
	LDD  R26,Y+1
	ST   X,R30
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x9
	LDD  R26,Y+2
	ST   X,R30
	RJMP _0x2040001
_rtc_set_time:
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x1
	RCALL _i2c_write
	LD   R30,Y
	ST   -Y,R30
	RCALL _bin2bcd
	RCALL SUBOPT_0x7
	LDD  R30,Y+1
	ST   -Y,R30
	RCALL _bin2bcd
	RCALL SUBOPT_0x7
	LDD  R30,Y+2
	ST   -Y,R30
	RCALL _bin2bcd
_0x2040002:
	ST   -Y,R30
	RCALL _i2c_write
_0x2040001:
	RCALL _i2c_stop
	ADIW R28,3
	RET

	.DSEG
_dig:
	.BYTE 0xE
_number_razr:
	.BYTE 0x4
_ind:
	.BYTE 0x4
_morgmin:
	.BYTE 0x1
_morghour:
	.BYTE 0x1
_swth_down:
	.BYTE 0x1
_swth_up:
	.BYTE 0x1

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x0:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x1:
	LDI  R30,LOW(0)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2:
	SUBI R30,-LOW(_dig)
	LD   R30,Z
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x3:
	LDI  R30,0
	SBIC 0x16,7
	LDI  R30,1
	COM  R30
	AND  R30,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4:
	LDI  R30,LOW(1)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x5:
	RCALL _i2c_start
	LDI  R30,LOW(208)
	ST   -Y,R30
	RCALL _i2c_write
	LDD  R30,Y+1
	ST   -Y,R30
	RJMP _i2c_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x6:
	RCALL _i2c_start
	LDI  R30,LOW(209)
	ST   -Y,R30
	RJMP _i2c_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x7:
	ST   -Y,R30
	RJMP _i2c_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x8:
	RCALL _i2c_start
	LDI  R30,LOW(208)
	RJMP SUBOPT_0x7

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x9:
	RCALL _i2c_read
	ST   -Y,R30
	RJMP _bcd2bin


	.CSEG
	.equ __i2c_dir=__i2c_port-1
	.equ __i2c_pin=__i2c_port-2
_i2c_init:
	cbi  __i2c_port,__scl_bit
	cbi  __i2c_port,__sda_bit
	sbi  __i2c_dir,__scl_bit
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay2
_i2c_start:
	cbi  __i2c_dir,__sda_bit
	cbi  __i2c_dir,__scl_bit
	clr  r30
	nop
	sbis __i2c_pin,__sda_bit
	ret
	sbis __i2c_pin,__scl_bit
	ret
	rcall __i2c_delay1
	sbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	sbi  __i2c_dir,__scl_bit
	ldi  r30,1
__i2c_delay1:
	ldi  r22,7
	rjmp __i2c_delay2l
_i2c_stop:
	sbi  __i2c_dir,__sda_bit
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
__i2c_delay2:
	ldi  r22,13
__i2c_delay2l:
	dec  r22
	brne __i2c_delay2l
	ret
_i2c_read:
	ldi  r23,8
__i2c_read0:
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
__i2c_read3:
	sbis __i2c_pin,__scl_bit
	rjmp __i2c_read3
	rcall __i2c_delay1
	clc
	sbic __i2c_pin,__sda_bit
	sec
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	rol  r30
	dec  r23
	brne __i2c_read0
	ld   r23,y+
	tst  r23
	brne __i2c_read1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_read2
__i2c_read1:
	sbi  __i2c_dir,__sda_bit
__i2c_read2:
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay1

_i2c_write:
	ld   r30,y+
	ldi  r23,8
__i2c_write0:
	lsl  r30
	brcc __i2c_write1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_write2
__i2c_write1:
	sbi  __i2c_dir,__sda_bit
__i2c_write2:
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
__i2c_write3:
	sbis __i2c_pin,__scl_bit
	rjmp __i2c_write3
	rcall __i2c_delay1
	sbi  __i2c_dir,__scl_bit
	dec  r23
	brne __i2c_write0
	cbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	ldi  r30,1
	sbic __i2c_pin,__sda_bit
	clr  r30
	sbi  __i2c_dir,__scl_bit
	ret

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
